#include <LiquidCrystal.h>
#include <String.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

char message[] = 

("                Thanks to everyone at MENT 2017!                "); //Leave 16 spaces at beginning and end for screen to clear

int previous = 0;
int pos = 0;

int tempoPin = A0;    // select the input pin for the pot
int tempoValue = 0;  // variable to store the value coming from the pot

void setup() {
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 1);

  // Print a message to the LCD.
  // lcd.print(message);
}

void printLine(int refresh) {
  //Check if the current time since restart is a mod of refresh seconds,
  //if it is then update the display , it must also not equal the previously
  //stored value to prevent duplicate refreshes

  if ((millis() / 10) % refresh == 0 && previous != (millis() / 10)) {
    previous =  (millis() / 10); //Store the current time we entered for comparison on the next cycle
    lcd.setCursor(0, 0);//Set our draw position , set second param to 0 to use the top line
    char lcdTop[16];//Create a char array to store the text for the line
    int copySize = 16; // What is the size of our screen , this could probably be moved outside the loop but its more dynamic like this
    if (strlen(message) < 16)
    {
      //if the message is bigger than the current buffer use its length instead;
      copySize = strlen(message);
    }
    //Store the current position temporarily and invert its sign if its negative since we are going in reverse
    int tempPos = pos;
    if (tempPos < 0)
    {
      tempPos = -(tempPos);
    }
    //Build the lcd text by copying the required text out of our template message variable
    memcpy(&lcdTop[0], &message[tempPos], copySize);
    lcd.print(lcdTop);//Print it from position 0
    //Increase the current position and check if the position + 16 (screen size) would be larger than the message length, if it is go in reverse by inverting the sign.
    pos += 1;
    if (pos + 16 >= strlen(message)) // screen size
    {
      pos = 0;
      lcd.clear();
    }
  }
}

void loop() {
  tempoValue = analogRead(tempoPin);
  printLine(1);
  delay (tempoValue);
}

